import javax.persistence.*;

public class Main {

    /* This program works both in Java SE as well as Java EE environment */
    @PersistenceUnit private static EntityManagerFactory emf;

    public static void main(String... args) throws Exception {
        if(emf == null) { // no injection => Java SE
            System.out.println("Defaulting to Java SE enviroment");
            emf = Persistence.createEntityManagerFactory("pu1", null);
        }
        EntityManager em = emf.createEntityManager();
        if(args.length == 0) {
            System.out.println("Usage: java "+ Main.class.getName() + " <name...>");
            System.exit(1);
        }
        for(String id : args) {
            EntityTransaction et = em.getTransaction();
            et.begin();
            System.out.println("*******Finding event " + id);
            EventPK eventPK = new EventPK(id, EventInformationT.class.getSimpleName());
	    EventInformationT event = em.find(EventInformationT.class, eventPK);
            if(event == null) {
                System.out.println("Creating event " + id);
                event = new EventInformationT();
                event.setNotificationId(id);
                em.persist(event);
            } else {
                System.out.println("Found " + event);
            }
            System.out.println("*******Finding alarm " + id);
            EventPK alarmPK = new EventPK(id, AlarmT.class.getSimpleName());
	    AlarmT alarm = em.find(AlarmT.class, alarmPK);
            if(alarm == null) {
                System.out.println("Creating alarm " + id);
                alarm = new AlarmT();
                alarm.setNotificationId(id);
                // not necessary, as we have PKasFK between Alarm & Event
                // alarm.setEvent(event); 
                em.persist(alarm);
            } else {
                System.out.println("Found " + alarm);
            }
            et.commit();
        }
        em.close();
    }
}
